	AddCSLuaFile("autorun/client/cl_hevsuit_core.lua")
	AddCSLuaFile("autorun/client/cl_hevsuit_sounds.lua")
	local function AddResourceDownloadDir(dir) // recursively adds everything in a directory to be downloaded by client
		local list = file.FindDir("../"..dir.."/*")
		for _, fdir in pairs(list) do
			if fdir != ".svn" then // don't spam people with useless .svn folders
				AddResourceDownloadDir(fdir)
			end
		end
	 
		for k,v in pairs(file.Find("../"..dir.."/*")) do
			resource.AddFile(dir.."/"..v)
		end
	end
 
	AddResourceDownloadDir("sound/hl1fvox")
	
local HEV_MAJOR_FRACTURE=1;
local HEV_MINOR_FRACTURE=2;
local HEV_INTERNAL_BLEEDING=3;
local HEV_BLEEDING_STOPPED=4;
local HEV_BLOOD_LOSS=5;
local HEV_MAJOR_LACERATION=6;
local HEV_MINOR_LACERATION=7;
local HEV_POISON=8;
local HEV_ANTI_TOXIN=9;
local HEV_BIOHAZARD=10;
local HEV_NERVEGAS=11;
local HEV_RADIATION=12;
local HEV_SHOCK=13;
local HEV_HEAT=14;
local HEV_AUTOMEDIC_ON=15;
local HEV_MORPHINE=16;
local HEV_NEARDEATH=17;
local HEV_HEALTH_CRITICAL=18;
local HEV_SEEK_MEDICAL_ATTENTION=19;


local RESTORE_AFTER_30_SECONDS=30;
local RESTORE_AFTER_5_MINUTES=300;

local ADD_TO_QUEUE=true;
local DONT_ADD_TO_QUEUE=false;

local function SendHEVSUITMessage(message,player,TYPE,TIME,BOOL)
	umsg.Start(message, player)
	umsg.Short( TYPE )
	umsg.Short( TIME )
	umsg.Bool( BOOL )
	umsg.End()
end

local function HEVSUITDAMAGE(ply, inflictor, attacker, amount, dmginfo) //Called on normal damages
	if IsValid(ply) && ply:IsPlayer() then
		local HealthPrev=ply:Health();
		local trivial;	
		local major;
		local critical;
		local tookpoison=false;
		local damagetype=dmginfo:GetDamageType();
		local lastdamage=amount;
		local currplyhealth=ply:Health()-amount;

		trivial = (currplyhealth > 75 || lastdamage < 5);	//ain't hurt.
		major = (lastdamage >= 25); 		 				//That's gotta hurt
		critical = (currplyhealth < 30); 					//OH MY GOD
			if lastdamage<=0 then return end
			if dmginfo:IsDamageType(DMG_CRUSH) && major then 
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_MAJOR_FRACTURE,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			elseif dmginfo:IsDamageType(DMG_FALL) || dmginfo:IsDamageType(DMG_CRUSH) || dmginfo:IsDamageType(DMG_CLUB)then
					if major then
						SendHEVSUITMessage("hevsuit_damage", ply, HEV_MAJOR_FRACTURE,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
					else
						SendHEVSUITMessage("hevsuit_damage", ply, HEV_MINOR_FRACTURE,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
					end
			elseif dmginfo:IsDamageType(DMG_BULLET) then
				if major then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_INTERNAL_BLEEDING,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_BLEEDING_STOPPED,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
				else	
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_BLOOD_LOSS,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
				end
			elseif dmginfo:IsDamageType(DMG_SLASH) then
				if (major) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_MAJOR_LACERATION,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
				else
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_MINOR_LACERATION,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
				end
			elseif dmginfo:IsDamageType(DMG_SONIC) then
				if major then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_INTERNAL_BLEEDING,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
				end
			elseif dmginfo:IsDamageType(DMG_POISON) || dmginfo:IsDamageType(DMG_PARALIZE) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_POISON,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_ANTI_TOXIN,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
					tookpoison=true;
			elseif dmginfo:IsDamageType(DMG_ACID) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_BIOHAZARD,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			elseif dmginfo:IsDamageType(DMG_NERVEGAS) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_NERVEGAS,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			elseif dmginfo:IsDamageType(DMG_RADIATION) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_RADIATION,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			elseif dmginfo:IsDamageType(DMG_SHOCK) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_SHOCK,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			elseif dmginfo:IsDamageType(DMG_BURN) then
					SendHEVSUITMessage("hevsuit_damage", ply, HEV_HEAT,RESTORE_AFTER_30_SECONDS,DONT_ADD_TO_QUEUE)
			end
			
			if !trivial && major && HealthPrev >= 75 && !tookpoison then
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_AUTOMEDIC_ON,RESTORE_AFTER_5_MINUTES,ADD_TO_QUEUE)
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_MORPHINE,RESTORE_AFTER_5_MINUTES,ADD_TO_QUEUE)
			end
			
			if (!trivial && critical && HealthPrev < 75 && !tookpoison)then
				if currplyhealth<6 then
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_NEARDEATH,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
				elseif currplyhealth<20 then
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_HEALTH_CRITICAL,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
				end
				
				if math.random(0,3)==0 && HealthPrev < 50 then
				SendHEVSUITMessage("hevsuit_damage", ply, HEV_SEEK_MEDICAL_ATTENTION,RESTORE_AFTER_30_SECONDS,ADD_TO_QUEUE)
				end
			end
	end
end
hook.Add("EntityTakeDamage", "HEVSUITDAMAGE",HEVSUITDAMAGE)